import jp.jig.jiglet.*;

public class Address extends Jiglet {
	String[][] data;
	void sort() {
		for (int i = 0; i < data.length; i++) {
			if (data[i][0] == null) {
				String[][] d2 = new String[data.length - 1][];
				arraycopy(data, 0, d2, 0, i);
				arraycopy(data, i + 1, d2, i, data.length - i - 1);
				data = d2;
				break;
			}
		}
		for (int i = 0; i < data.length - 1; i++) {
			for (int j = i + 1; j < data.length; j++) {
				if (data[i][1].compareTo(data[j][1]) > 0) {
					String[] tmp = data[i];
					data[i] = data[j];
					data[j] = tmp;
				}
			}
		}
		save();
	}
	int find(String[] d) {
		for (int i = 0; i < data.length; i++)
			if (d == data[i])
				return i;
		return -1;
	}
	
	int state = 0; // 0:ꗗA1:ڍ
	String[] data1;
	int cursor0 = 0;
	int view0 = 0;
	int cursor1 = 0;
	String label;
	
	public void main() {
		load();
		clearKey();
		list();
	}
	int version = 0;
	void save() {
		int size = getLengthSP();
		byte[] b = new byte[size];
		int nb = 0;
		b[nb++] = (byte)version;
		
		b[nb++] = (byte)(data.length >> 8);
		b[nb++] = (byte)data.length;
		for (int i = 0; i < data.length; i++) {
			String[] ss = data[i];
			b[nb++] = (byte)ss.length;
			for (int j = 0; j < ss.length; j++) {
				byte[] b2 = ss[j].getBytes();
				b[nb++] = (byte)(b2.length >> 8);
				b[nb++] = (byte)b2.length;
				arraycopy(b2, 0, b, nb, b2.length);
				nb += b2.length;
			}
		}
		writeSP(0, b);
	}
	void load() {
		int size = getLengthSP();
		byte[] b = readSP(0, size);
		int nb = 0;
		if (b[nb++] != version)
			return;
		
		int n = ((b[nb++] & 0xff) << 8) | (b[nb++] & 0xff);
		String[][] d = new String[n][];
		for (int i = 0; i < d.length; i++) {
			String[] ss = new String[b[nb++] & 0xff];
			d[i] = ss;
			for (int j = 0; j < ss.length; j++) {
				n = ((b[nb++] & 0xff) << 8) | (b[nb++] & 0xff);
				ss[j] = new String(b, nb, n);
				nb += n;
			}
		}
		data = d;
	}
	void list() {
		state = 0;
		setSoftLabel(label = "VK");
		for (;;) {
			int key = getKey();
			if (key == KEY_UP) {
				if (cursor0 == 0)
					cursor0 = data.length - 1;
				else
					cursor0--;
			} else if (key == KEY_DOWN) {
				if (cursor0 == data.length - 1)
					cursor0 = 0;
				else
					cursor0++;
			} else if (key == KEY_SELECT) {
				String[] dat = data[cursor0];
				if (detail(dat)) {
					sort();
					int c = find(dat);
					if (c != -1) {
						cursor0 = c;
					} else {
						if (cursor0 >= data.length)
							cursor0 = data.length - 1;
					}
				}
			} else if (key == KEY_SOFT) {
				String[] dat = new String[] { "", "", "", "", "" };
				if (detail(dat)) {
					if (dat[0] != null) {
						String[][] d2 = new String[data.length + 1][];
						arraycopy(data, 0, d2, 0, data.length);
						d2[data.length] = dat;
						data = d2;
						cursor0 = find(dat);
						
						sort();
					}
				}
			}
			repaint();
			sleep(1);
		}
	}
	//------------------------------------------------------------------
	String[] menu;
	int cursorm = 0; // menu
	int menuw;
	int menuh;
	
	int menu(String[] s) {
		if (s != null) {
			String bklabel = label;
			setSoftLabel(label = "߂");
			menuw = 0;
			for (int i = 0; i < s.length; i++) {
				int w = stringWidth(s[i]);
				if (w > menuw) {
					menuw = w;
				}
			}
			menuh = s.length * (getFontHeight() + 1) + 1;
			
			menu = s;
			cursorm = 0;
			for (;;) {
				int key = getKey();
				if (key == KEY_UP) {
					if (cursorm == 0)
						cursorm = menu.length - 1;
					else
						cursorm--;
				} else if (key == KEY_DOWN) {
					if (cursorm == menu.length - 1)
						cursorm = 0;
					else
						cursorm++;
				} else if (key == KEY_SELECT) {
					break;
				} else if (key == KEY_SOFT) {
					cursorm = -1;
					break;
				}
				repaint();
				sleep(1);
			}
			menu = null;
			setSoftLabel(label = bklabel);
			return cursorm;
		} else {
			// graphics
			if (menu == null)
				return 0;
			
			int fh = getFontHeight();
			int lh = fh + 2;
			int x = (DW - menuw) / 2;
			int y = (DH - menuh) / 2;
			draw3DButton(x, y, menuw, menuh);
			for (int i = 0; i < menu.length; i++) {
				if (i == cursorm) {
					setColor(getSystemColor(SYSTEM_COLOR_MENU_CURSOR));
					fillRect(x, y + lh * i, menuw, lh + 1);
					setColor(getSystemColor(SYSTEM_COLOR_MENU_FONT2));
				} else {
					setColor(getSystemColor(SYSTEM_COLOR_MENU_FONT1));
				}
				drawString(menu[i], x, y + lh * i + fh);
			}
			return 0;
		}
	}
	int bkstate = 0;
	// res: duty
	boolean detail(String[] d) {
		boolean duty = false;
		String bklabel = label;
		setSoftLabel(label = "߂");
		data1 = d;
		bkstate = state;
		cursor1 = data1[2].length() > 0 ? 2 : 0;
		state = 1;
		for (;;) {
			int key = getKey();
			if (key == KEY_UP) {
				if (cursor1 == 0)
					cursor1 = DETAIL.length - 1;
				else
					cursor1--;
			} else if (key == KEY_DOWN) {
				if (cursor1 == DETAIL.length - 1)
					cursor1 = 0;
				else
					cursor1++;
			} else if (key == KEY_SELECT) {
				if (cursor1 == 0 || cursor1 == 1 || cursor1 == 4) {
					String org = data1[cursor1];
					data1[cursor1] = inputText(org, TEXT_KANA);
					duty |= !org.equals(data1[cursor1]);
				} else if (cursor1 == 2) {
					int type = 2;
					if (data1[cursor1].length() > 0)
						type = menu(new String[] { "db", "erdb", "ҏW" });
					if (type == 0) {
						launch("tel:" + data1[cursor1], ENCODE_SJIS, LAUNCH_KEEP_ALIVE);
					} else if (type == 1) {
						launch("tel-av:" + data1[cursor1], ENCODE_SJIS, LAUNCH_KEEP_ALIVE);
					} else if (type == 2) {
						String org = data1[cursor1];
						data1[cursor1] = inputText(org, TEXT_NUMBER);
						duty |= !org.equals(data1[cursor1]);
					}
				} else if (cursor1 == 3) {
					int type = 1;
					if (data1[cursor1].length() > 0)
						type = menu(new String[] { "[", "ҏW" });
					if (type == 0) {
						launch("tel:" + data1[cursor1], ENCODE_SJIS, LAUNCH_KEEP_ALIVE);
					} else if (type == 1) {
						String org = data1[cursor1];
						data1[cursor1] = inputText(org, TEXT_NUMBER);
						duty |= !org.equals(data1[cursor1]);
					}
				} else if (cursor1 == 5) {
					break;
				} else if (cursor1 == 6) {
					if (showDialog("폜܂H", DIALOG_TYPE_NO_YES ) == 0) {
						data1[0] = null;
						duty = true;
						break;
					}
				}
			} else if (key == KEY_IAPP || key == KEY_SOFT) {
				break;
			}
			repaint();
			sleep(1);
		}
		state = bkstate;
		setSoftLabel(label = bklabel);
		return duty;
	}
	String[] DETAIL = { "O", "", "db", "MAIL", "", "> ߂", "> 폜" };
	public void paint(boolean allDrawFlag) {
		if (data == null)
			return;
		
		setFont(0);
		setColor(getSystemColor(SYSTEM_COLOR_MENU_BG));
		fillRect(0, 0, DW, DH);
		
		int fh = getFontHeight();
		int lh = fh + 2;
		if (state == 0) {
			if (data.length == 0) {
				setColor(getSystemColor(SYSTEM_COLOR_MENU_FONT1));
				drawString("AhXf[^܂", 0, lh * 0 + fh);
				drawString("[VK]j[œ͂Ă", 0, lh * 1 + fh);
			} else {
				int vlen = DH / lh;
				if (view0 + vlen == cursor0) {
					view0++;
				} else if (view0 == cursor0 + 1) { // || view0 + vlen - 2 > cursor0) {
					view0--;
				} else if (view0 == 0 && cursor0 > view0 + vlen) {
					view0 = data.length - vlen;
				} else if (cursor0 < view0 || cursor0 > view0 + vlen) {
					view0 = cursor0;
				}
				for (int i = 0; i < vlen; i++) {
					if (i + view0 < 0 || i + view0 >= data.length)
						break;
					if (i + view0 == cursor0) {
						setColor(getSystemColor(SYSTEM_COLOR_MENU_CURSOR));
						fillRect(0, lh * i, DW, lh + 1);
						setColor(getSystemColor(SYSTEM_COLOR_MENU_FONT2));
					} else {
						setColor(getSystemColor(SYSTEM_COLOR_MENU_FONT1));
					}
					drawString(data[i + view0][0], 0, lh * i + fh);
				}
				int barh = DH;
				int barlen = barh * vlen / data.length;
				if (barlen < barh) {
					setColor(getSystemColor(SYSTEM_COLOR_SCROLL_BG));
					fillRect(DW - 3, 0, 3, barh);
					setColor(getSystemColor(SYSTEM_COLOR_SCROLL_BAR));
					int barpos = (barh - barlen) * view0 / (data.length - vlen);
					fillRect(DW - 3, barpos, 3, barlen);
				}
			}
		} else if (state == 1) {
			int offw = 4 / 2 * fh + fh / 2;
			for (int i = 0; i < DETAIL.length; i++) {
				if (i == cursor1) {
					setColor(getSystemColor(SYSTEM_COLOR_MENU_CURSOR));
					fillRect(offw, lh * i, DW - offw, lh + 1);
					setColor(getSystemColor(SYSTEM_COLOR_MENU_FONT2));
				} else {
					setColor(getSystemColor(SYSTEM_COLOR_MENU_FONT1));
				}
				String s1, s2;
				if (i < DETAIL.length - 2) {
					s1 = data1[i];
					s2 = DETAIL[i];
				} else {
					s1 = DETAIL[i];
					s2 = "";
				}
				drawString(s1, offw, lh * i + fh);
				setColor(getSystemColor(SYSTEM_COLOR_MENU_FONT1));
				drawString(s2, 0, lh * i + fh);
			}
		}
		menu(null);
	}
}
